<?php
/**
 * Simple Multi User Out of Office Responder
 * IMP plugin
 */

@define('IMP_BASE', '/usr/share/horde3/imp');
$authentication = OP_HALFOPEN;
require_once IMP_BASE . '/lib/base.php';
require_once IMP_BASE . '/lib/Folder.php';

require_once 'Horde/Prefs/UI.php';
require IMP_BASE . '/config/prefs.php';
$app = 'imp';

$prefs_url = IMP::prefsURL(true);
$username = $_SESSION['imp']['user'];

echo_header();
connect_to_db();
check_and_create_user();
if(action_provided()) {
	execute_action();
}
show_status();
echo_footer();

require $registry->get('templates', 'horde') . '/common-footer.inc';

function connect_to_db() {
	mysql_pconnect("host", "user", "password") or die("Cannot connect to SQL server: " . mysql_error());
	mysql_select_db("database") or die("Cannot select database: " . mysql_error());
}

function action_provided() {
	if(isset($_POST["action"])) {
		return $_POST["action"];
	}
}

function execute_action() {
	global $username;
	if($_POST["vacation_active"]=="Yes") {
		$vacation_active=1;
	} else {
		$vacation_active=0;
	}
	$sql=sprintf("update User set vacation_active=%s, vacation_message=%s where login=%s",
		$vacation_active,
		isset($_POST["vacation_message"]) ? quote_smart($_POST["vacation_message"]) : "''",
		quote_smart($username));
	$result=mysql_query($sql) or die ("MySQL query failed: " . mysql_error());
	if($vacation_active == 0) {
		$sql=sprintf("delete from KnownSender where user=%s",
			quote_smart($username));
		$result=mysql_query($sql) or die ("MySQL query failed: " . mysql_error());
	}
	echo "<div class=\"message\">Settings saved</div>\n";
}

function check_and_create_user() {
	global $username;
	$sql=sprintf("select login from User where login=%s",
		quote_smart($username));
	$result=mysql_query($sql) or die ("MySQL query failed: " . mysql_error());
	if(! mysql_affected_rows()) {
		$sql=sprintf("insert into User (login, vacation_active, vacation_message) values (%s, 0, \"\")",
			quote_smart($username));
		$result=mysql_query($sql) or die ("MySQL query failed: " . mysql_error());
		echo "<div class=\"message\">User created in vacation database</div>\n";
	}
}

function echo_header() {
	global $username;

	Prefs_UI::generateHeader();
	echo('<div class="header">');
	Prefs_UI::generateNavigationCell('outofoffice');
	echo("Out of Office Settings for $username");
	echo("</div>\n");
?>
<script language="javascript" type="text/javascript">
function activate_area() {
	document.getElementById("area").disabled=false;
}
function deactivate_area() {
	document.getElementById("area").disabled=true;
}
</script>
<style type="text/css">
div.message {
	background:#e6ff96;
}
div.error {
	background:#ffd296;
}
div.signature {
	text-align: right;
	background:#b39369;
}
</style>
<?
}

function echo_footer() {
	echo('<div class="signature">Simple Multi User Out Of Office Responder - smuooor</div>');
}

function show_status() {
	global $username;
	global $prefs_url;

	echo("<form method=\"post\" action=\"". $_SERVER["PHP_SELF"] ."\">\n");
	$sql=sprintf("select vacation_active, vacation_message from User where login=%s",
		quote_smart($username));
	$result=mysql_query($sql) or die ("MySQL query failed: " . mysql_error());
	while ($line = mysql_fetch_array($result, MYSQL_ASSOC)) {
		echo("Out of office:<br />\n");

		echo("<input onclick=\"activate_area()\" type=\"radio\" name=\"vacation_active\" value=\"Yes\"");
		if($line["vacation_active"]) {
			echo(' checked="yes" ');
		}
		echo("/>Yes\n<br />\n");

		echo("<input onclick=\"deactivate_area()\" type=\"radio\" name=\"vacation_active\" value=\"No\"");
		if(! $line["vacation_active"]) {
			echo(' checked="yes" ');
		}
		echo(" />No\n<br />\n");

		echo("<br />\n");

		echo("Message:<br />\n");
		echo("<textarea id=\"area\" name=\"vacation_message\" rows=\"10\" cols=\"72\" ");
		if(! $line["vacation_active"]) {
			echo(" disabled=\"true\" ");
		};
		echo(">\n");
		echo ($line["vacation_message"]);
		echo("</textarea>\n <br />\n");

		echo("<input type=\"hidden\" name=\"action\" value=\"1\" />\n");

		echo("<input type=\"submit\" value=\"Save\" />\n");
	}
	echo("<a href=\"$prefs_url\">Back to preferences</a><br />\n");

	echo("</form>\n");

}

function quote_smart($value)
{
   // Strip slashes
   if (get_magic_quotes_gpc()) {
       $value = stripslashes($value);
   }
   // Quote if not a number or a numeric string
   if (!is_numeric($value)) {
       $value = "'" . mysql_real_escape_string($value) . "'";
   }
   return $value;
}

function debug($string) {
	echo "<div class=\"debug\">$string</div>\n";
}
?>
